/* \mainpage

s/qmail -- fast, secure, and reliable email transmission
========================================================

WHAT IT IS:
----------
- s/qmail is a fork of qmail (1.03) including the 
  features of the Spamcontrol patch together with
  IPv6 capabilities and 64 bit clean
- s/qmail is API- and plug-in-compatible with qmail,
  thus add-ons like vpopmail, ezmlm, and vmailmgr
  and many others work without changes 
- TLS 1.3 enabled using ucspi-ssl
- Wide scale QMTPS support
- s/qmail uses the concept of D.J. Bernstein's
  coding without compromise 
- Linux systemd compatible


INCULDING:
--------
The following (DJB) packages are included:

- checkpassword (as qmail-authuser)
- fastforward
- qmailanalog 
- qmail-mrtg


REQUIREMENTS:
------------
- fehQlibs (-15) -- can't build w/o it
- ucspi-ssl (> 0.11.x) -- won't run without it
- ucspi-tcp6 (generating the cdb)
- daemontools package (supervising the services),
  any other will do as well
- libidn2 for EAI support


INSTALLATION:
------------
- Read the INSTALL document


INTERNAL CHANGES FROM QMAIL:
---------------------------
- Group is now 'sqmail' instead of 'qmail'
- Exttodo + Bigtodo is default
- qmail(-queue) supports additional control tokens and return codes
- Old qmail code for sendmail compatibility removed 
- Added QMTPS capabilities
- IPv6 supported by default
- 64 + 32 bit clean
- GCC 10 + clang compliant (developed on FreeBSD)
- SPF lookup 
- SRS: srsforward & srsreverse
- SMTPUTF8 + IDN2 support
- fehQlibs DNS stub resolver


USER INTERFACE CHANGES:
----------------------
- Port separator is ';' instead of ':' (due to IPv6)
- Added SPF capabilities for qmail-smtpd + spfquery for testing
- Added new DNS test routines: dnsfq, dnscname, dnstxt
- Added fastforward package
- Added qmailanalog and qmail-mrtg
- Additional TLS control files for X.509 certificates, 
  key files and verification handling
- RECIPIENTS extension from Spamcontol
- Added PAMs for Recipient verification
  (qmail-vmailuser, qmail-smtpam)
- Added qmail-authuser PAM for SMTP and POP3 authentication; 
  supporting Dovecot natively
 
s/qmail (4.0) -- this README is not comprehensive yet 

See doc/CHANGELOG for version information.

Date: September, 13th 2020 (feh)
